import sys
pwd = "uNf3tTer3d"

taps = [69, 67, 65]

EVIL=True

def gen():
    bits = []
    for i, c in enumerate(pwd):
        n = ord(c)
        for j in range(7):
            bits.append(int(bool(n & (1 << j))))

    #print >>sys.stderr, "".join(map(str, bits))

    def clock():
        fb = bits[0]
        for i in range(70):
            if i == 69:
                bits[i] = fb
            else:
                bits[i] = bits[i+1]
                if (i-1) in taps:
                    bits[i] ^= fb

    for i in range(70):
        clock()

    print >>sys.stderr, "".join(map(str, bits))
    return bits

expected = gen()

g_id = 0

g_fets = []
g_nodes = set()

class Node(object):
    def __init__(self, name=None, fixed=False):
        if name is None or (EVIL and not fixed):
            global g_id
            name = "n%d" % g_id
            self.active = False
            g_id += 1
        else:
            self.active = fixed
            if not fixed:
                i = 0
                nn = name
                while name in g_nodes:
                    name = nn + "_%d" % i
                    i += 1
        g_nodes.add(name)
        self.name = name
    def gen(self):
        if not self.active:
            self.active = True
            return "mkfifo %s\n" % self.name
        else:
            return ""

class FET(object):
    def __init__(self, s, g, d):
        global g_fets
        self.s = s
        self.g = g
        self.d = d
        g_fets.append(self)
    def gen(self):
        return self.s.gen() + self.g.gen() + self.d.gen() + \
            "\"$mosfet\" <%s %s%s >%s &\n" % (self.s.name, self.POL, self.g.name, self.d.name)

class PFET(FET):
    POL = "-"

class NFET(FET):
    POL = ""

def I(d, q):
    NFET(vss, d, q)
    PFET(q, d, vdd)

def DI(d, q, l):
    d1h = Node("d1h")
    d1l = Node("d1l")
    d1 = Node("d1")
    d2h = Node("d2h")
    d2l = Node("d2l")
    d2hl = Node("d2hl")
    d2ll = Node("d2ll")
    d2 = Node("d2")

    NFET(vss, d, d1l)
    NFET(d1l, clk1, d1)
    PFET(d1, nclk1, d1h)
    PFET(d1h, d, vdd)

    NFET(vss, d1, d2l)
    NFET(d2l, clk2, d2)
    PFET(d2, nclk2, d2h)
    PFET(d2h, d1, vdd)

    NFET(vss, l, d2ll)
    NFET(d2ll, load, d2)
    PFET(d2, nload, d2hl)
    PFET(d2hl, l, vdd)

    NFET(vss, d2, q)
    PFET(q, d2, vdd)

def XOR(a, na, b, nb, q):
    l1 = Node("xl1")
    l2 = Node("xl2")
    h1 = Node("xh1")
    h2 = Node("xh2")

    NFET(vss, a, l1)
    NFET(l1, b, q)

    NFET(vss, na, l2)
    NFET(l2, nb, q)

    PFET(h1, a, vdd)
    PFET(q, nb, h1)

    PFET(h2, na, vdd)
    PFET(q, b, h2)

vdd = Node('/dev/null', True)
vss = Node('/dev/zero', True)
clk1 = Node('clock1', True)
clk2 = Node('clock2', True)
load = Node('load', True)
nload = Node('nload')
nclk1 = Node('nclk1')
nclk2 = Node('nclk2')
I(load, nload)
I(clk1, nclk1)
I(clk2, nclk2)
correct = Node('correct', True)


cur_q = fb = Node('b_00')
cur_qi = fb_i = Node('b_00_i')

b_nodes = [fb]
bi_nodes = [fb_i]

for i in range(70):
    if i == 69:
        d = fb
    else:
        d = next_q = Node('b_%02d' % (i+1))
        next_qi = Node('b_%02d_i' % (i+1))
        if (i-1) in taps:
            d = Node('b_%02d_x' % (i+1))
            XOR(next_q, next_qi, fb, fb_i, d)
    DI(d, cur_qi, Node('in_%02d' % i, True))
    I(cur_qi, cur_q)
    cur_q = next_q
    cur_qi = next_qi
    b_nodes.append(cur_q)
    bi_nodes.append(cur_qi)

tp = vdd

for i in range(70):
    if expected[i]:
        b = bi_nodes[i]
    else:
        b = b_nodes[i]
    if i != 69:
        qp = Node()
    else:
        qp = correct
    NFET(vss, b, correct)
    PFET(qp, b, tp)
    tp = qp


circuit = ""

for fet in g_fets:
    circuit += fet.gen()

sh = open("template.sh", "r").read()
sh = sh.replace("%CIRCUIT%", circuit)
print sh
